FQ.MD.WEB/ViewModels/CompanyViewModels.cs
using FQ.MD.WEB.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FQ.MD.WEB.ViewModels
{
    public class CompanyViewModel
    {
        public int CompanyId { get; set; }

        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string CompanyName { get; set; }
        [DataType(DataType.PhoneNumber)]
        public string CompanyPhone { get; set; }
        [DataType(DataType.EmailAddress)]
        public string CompanyEmail { get; set; }
        public string CompanyWebsite { get; set; }
        public bool IsActive { get; set; }
        public string Remark { get; set; }

        public string Active { get; set; }
        public string Actions { get; set; }
    }
}

FQ.MD.WEB/Controllers/CompaniesController.cs
using FQ.MD.WEB.ViewModels.JSON;
using FQ.MD.WEB.Helpers;
using FQ.MD.WEB.Models;
using FQ.MD.WEB.Resources;
using FQ.MD.WEB.Services;
using FQ.MD.WEB.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;

namespace FQ.MD.WEB.Controllers
{
    [Authorize]
    public class CompaniesController : BaseController
    {
        private CompanyServices _services = new CompanyServices();

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public JsonResult Index(DataTables model)
        {
            var searchKeywords = !String.IsNullOrEmpty(model.search.value) ? model.search.value.ToLower() : "";

            string sortBy = "CompanyName";
            bool sortDir = true;

            if (model.order != null)
            {
                sortBy = model.columns[model.order[0].column].data;
                sortDir = model.order[0].dir.ToLower() == "asc";
            }

            Expression<Func<GT_MASTER_COMPANIES, bool>> filter = u => u.CompanyName.ToLower().Contains(searchKeywords);
            Func<IQueryable<GT_MASTER_COMPANIES>, IOrderedQueryable<GT_MASTER_COMPANIES>> orderBy = q => sortDir ? q.OrderBy(u => u.CompanyName) : q.OrderByDescending(u => u.CompanyName);

            if (sortBy == "Active")
            {
                orderBy = q => sortDir ? q.OrderBy(u => u.IsActive) : q.OrderByDescending(u => u.IsActive);
            }

            var models = _services.Get(filter: filter, orderBy: orderBy, start: model.start, take: model.length)
                .Select(c => new CompanyViewModel
                {
                    CompanyName = c.CompanyName,
                    Active = DisplayActiveIcon(c.IsActive),
                    Actions = DisplayActions(UserAuthorization, c.CompanyId, null)
                });

            var totalResultsCount = _services.Get().Count();
            var recordsFiltered = String.IsNullOrEmpty(model.search.value) ? totalResultsCount : _services.Get(filter: filter).Count();

            return Json(new
            {
                draw = model.draw,
                recordsTotal = totalResultsCount,
                recordsFiltered = recordsFiltered,
                data = models.ToList()
            });
        }

        public ActionResult Add()
        {
            return View();
        }

        public ActionResult Edit(int Id)
        {
            var model = _services.GetCompanyById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new CompanyViewModel();
            viewModel.CompanyId = model.CompanyId;
            viewModel.CompanyName = model.CompanyName;
            viewModel.CompanyPhone = model.CompanyPhone;
            viewModel.CompanyEmail = model.CompanyEmail;
            viewModel.CompanyWebsite = model.CompanyWebsite;
            viewModel.IsActive = model.IsActive;

            return View(viewModel);
        }

        public ActionResult Detail(int Id)
        {
            var model = _services.GetCompanyById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new CompanyViewModel();
            viewModel.CompanyId = model.CompanyId;
            viewModel.CompanyName = model.CompanyName;
            viewModel.CompanyPhone = model.CompanyPhone;
            viewModel.CompanyEmail = model.CompanyEmail;
            viewModel.CompanyWebsite = model.CompanyWebsite;
            viewModel.IsActive = model.IsActive;

            return View(viewModel);
        }

        public ActionResult Delete(int Id)
        {
            var model = _services.GetCompanyById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new CompanyViewModel();
            viewModel.CompanyId = model.CompanyId;
            viewModel.CompanyName = model.CompanyName;
            viewModel.CompanyPhone = model.CompanyPhone;
            viewModel.CompanyEmail = model.CompanyEmail;
            viewModel.CompanyWebsite = model.CompanyWebsite;
            viewModel.IsActive = model.IsActive;

            return View(viewModel);
        }
    }
}

FQ.MD.WEB/Views/Companies/Add.cshtml
@model FQ.MD.WEB.ViewModels.CompanyViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Add + " " + Res.Company;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Companies</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyName, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Phone</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyPhone, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyPhone, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Email</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyEmail, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyEmail, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Web</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyWebsite, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyWebsite, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Add" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Companies/Delete.cshtml
@model FQ.MD.WEB.ViewModels.CompanyViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Delete + " " + Res.Company;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Companies</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.CompanyId)
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Phone</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyPhone, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Email</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyEmail, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Web</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyWebsite, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Remark</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Remark, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Remark, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Delete" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Companies/Detail.cshtml
@model FQ.MD.WEB.ViewModels.CompanyViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Show + " " + Res.Company;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Companies</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        <label>@Model.CompanyName</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Phone</label>
                    <div class="col-md-6">
                        <label>@Model.CompanyPhone</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Email</label>
                    <div class="col-md-6">
                        <label>@Model.CompanyEmail</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Web</label>
                    <div class="col-md-6">
                        <label>@Model.CompanyWebsite</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked", @disabled = "disabled" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Companies/Edit.cshtml
@model FQ.MD.WEB.ViewModels.CompanyViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Edit + " " + Res.Company;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Companies</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.CompanyId)
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                        @Html.ValidationMessageFor(model => model.CompanyName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Phone</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyPhone, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyPhone, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Email</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyEmail, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyEmail, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Web</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.CompanyWebsite, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.CompanyWebsite, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Edit" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Companies/Index.cshtml
@using FQ.MD.WEB.Resources
@{
    ViewBag.Title = Res.Companies;
    var Message = (string)ViewBag.Message;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>

<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
            <div class="col-6 text-right">

            </div>
        </div>
    </div>
    <div class="card-body">
        <table id="datatable" class="table table-striped" style="width:100%">
            <thead>
                <tr>
                    <th> @Res.Company </th>
                    <th> @Res.IsActive </th>
                    <th></th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
</div>



@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $('#datatable').DataTable({
                "bStateSave": true,
                "processing": true,
                "serverSide": true,
                "ajax": {
                    url: "@Url.Action("Index", "Companies")",
                    type: 'POST'
                },
                "language": {
                    "search": "@Res.Search",
                    "searchPlaceholder": "@Res.Keywords",
                    "lengthMenu": "@Res.Show _MENU_ @Res.Entries",
                    "zeroRecords": "@Res.NoData",
                    "info": "",
                    "infoEmpty": "@Res.NoData",
                    "infoFiltered": "",
                    "paginate": { "first": "|<", "previous": "<", "next": ">", "last": ">|"

                    }
                },
                "columns": [
                     { "data": "CompanyName", "width": "70%" },
                     { "data": "Active", "className": 'text-center' },
                     { "data": "Actions", "className": 'text-right', "orderable": false }
                ]
            });
        });
    </script>
}